# coding: utf-8

"""
    Dockstore API

    This describes the dockstore API, a webservice that manages pairs of Docker images and associated metadata such as CWL documents and Dockerfiles used to build those images. Explore swagger.json for a Swagger 2.0 description of our API and explore openapi.yaml for OpenAPI 3.0 descriptions.  # noqa: E501

    OpenAPI spec version: 1.12.0-alpha.1-SNAPSHOT
    Contact: theglobalalliance@genomicsandhealth.org
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from jgreenepack.configuration import Configuration


class Limits(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'hosted_entry_count_limit': 'int',
        'hosted_entry_version_limit': 'int'
    }

    attribute_map = {
        'hosted_entry_count_limit': 'hostedEntryCountLimit',
        'hosted_entry_version_limit': 'hostedEntryVersionLimit'
    }

    def __init__(self, hosted_entry_count_limit=None, hosted_entry_version_limit=None, _configuration=None):  # noqa: E501
        """Limits - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._hosted_entry_count_limit = None
        self._hosted_entry_version_limit = None
        self.discriminator = None

        if hosted_entry_count_limit is not None:
            self.hosted_entry_count_limit = hosted_entry_count_limit
        if hosted_entry_version_limit is not None:
            self.hosted_entry_version_limit = hosted_entry_version_limit

    @property
    def hosted_entry_count_limit(self):
        """Gets the hosted_entry_count_limit of this Limits.  # noqa: E501


        :return: The hosted_entry_count_limit of this Limits.  # noqa: E501
        :rtype: int
        """
        return self._hosted_entry_count_limit

    @hosted_entry_count_limit.setter
    def hosted_entry_count_limit(self, hosted_entry_count_limit):
        """Sets the hosted_entry_count_limit of this Limits.


        :param hosted_entry_count_limit: The hosted_entry_count_limit of this Limits.  # noqa: E501
        :type: int
        """

        self._hosted_entry_count_limit = hosted_entry_count_limit

    @property
    def hosted_entry_version_limit(self):
        """Gets the hosted_entry_version_limit of this Limits.  # noqa: E501


        :return: The hosted_entry_version_limit of this Limits.  # noqa: E501
        :rtype: int
        """
        return self._hosted_entry_version_limit

    @hosted_entry_version_limit.setter
    def hosted_entry_version_limit(self, hosted_entry_version_limit):
        """Sets the hosted_entry_version_limit of this Limits.


        :param hosted_entry_version_limit: The hosted_entry_version_limit of this Limits.  # noqa: E501
        :type: int
        """

        self._hosted_entry_version_limit = hosted_entry_version_limit

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(Limits, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, Limits):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, Limits):
            return True

        return self.to_dict() != other.to_dict()
