# coding: utf-8

"""
    Dockstore API

    This describes the dockstore API, a webservice that manages pairs of Docker images and associated metadata such as CWL documents and Dockerfiles used to build those images. Explore swagger.json for a Swagger 2.0 description of our API and explore openapi.yaml for OpenAPI 3.0 descriptions.  # noqa: E501

    OpenAPI spec version: 1.12.0-alpha.1-SNAPSHOT
    Contact: theglobalalliance@genomicsandhealth.org
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from jgreenepack.configuration import Configuration


class VerificationInformation(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'metadata': 'str',
        'platform_version': 'str',
        'verified': 'bool'
    }

    attribute_map = {
        'metadata': 'metadata',
        'platform_version': 'platformVersion',
        'verified': 'verified'
    }

    def __init__(self, metadata=None, platform_version=None, verified=None, _configuration=None):  # noqa: E501
        """VerificationInformation - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._metadata = None
        self._platform_version = None
        self._verified = None
        self.discriminator = None

        if metadata is not None:
            self.metadata = metadata
        if platform_version is not None:
            self.platform_version = platform_version
        if verified is not None:
            self.verified = verified

    @property
    def metadata(self):
        """Gets the metadata of this VerificationInformation.  # noqa: E501


        :return: The metadata of this VerificationInformation.  # noqa: E501
        :rtype: str
        """
        return self._metadata

    @metadata.setter
    def metadata(self, metadata):
        """Sets the metadata of this VerificationInformation.


        :param metadata: The metadata of this VerificationInformation.  # noqa: E501
        :type: str
        """

        self._metadata = metadata

    @property
    def platform_version(self):
        """Gets the platform_version of this VerificationInformation.  # noqa: E501


        :return: The platform_version of this VerificationInformation.  # noqa: E501
        :rtype: str
        """
        return self._platform_version

    @platform_version.setter
    def platform_version(self, platform_version):
        """Sets the platform_version of this VerificationInformation.


        :param platform_version: The platform_version of this VerificationInformation.  # noqa: E501
        :type: str
        """

        self._platform_version = platform_version

    @property
    def verified(self):
        """Gets the verified of this VerificationInformation.  # noqa: E501


        :return: The verified of this VerificationInformation.  # noqa: E501
        :rtype: bool
        """
        return self._verified

    @verified.setter
    def verified(self, verified):
        """Sets the verified of this VerificationInformation.


        :param verified: The verified of this VerificationInformation.  # noqa: E501
        :type: bool
        """

        self._verified = verified

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(VerificationInformation, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, VerificationInformation):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, VerificationInformation):
            return True

        return self.to_dict() != other.to_dict()
